%global pypi_name pulpcore
%global wrappers gunicorn pulpcore-worker
%global commitId 900495559098e55013b38381804582fdd567bd5b

%if 0%{?rhel} == 8
%global component_prefix 3x
%endif

Name:           python%{?component_prefix}-%{pypi_name}
Version:        3.21.3
Release:        1%{?dist}
Summary:        Pulp Django Application and Related Modules

License:        GPLv2+
URL:            https://github.com/pulp/pulpcore
Source0:        python-pulpcore-900495559098e55013b38381804582fdd567bd5b.tar.gz
BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-setuptools >= 39.2.0

%description
Pulp is a platform for managing repositories of content, such as software
packages, and pushing that content out to large numbers of consumers.

Using Pulp you can:
- Locally mirror all or part of a repository
- Host your own content in a new repository
- Manage content from multiple sources in one place
- Promote content through different repos in an organized way

%package -n     python%{python3_pkgversion}-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}

Requires:       python%{python3_pkgversion}-PyYAML >= 5.1.1
Requires:       python%{python3_pkgversion}-PyYAML < 6.1.0
Requires:       python%{python3_pkgversion}-aiodns >= 3.0.0
Requires:       python%{python3_pkgversion}-aiodns < 3.1
Requires:       python%{python3_pkgversion}-aiofiles = 22.1.0
Requires:       python%{python3_pkgversion}-aiohttp >= 3.8.1
Requires:       python%{python3_pkgversion}-aiohttp < 3.9
Requires:       python%{python3_pkgversion}-aioredis >= 2.0.1
Requires:       python%{python3_pkgversion}-aioredis < 2.1
Requires:       python%{python3_pkgversion}-asyncio-throttle >= 1.0
Requires:       python%{python3_pkgversion}-asyncio-throttle < 2
Requires:       python%{python3_pkgversion}-backoff >= 2.1.2
Requires:       python%{python3_pkgversion}-backoff < 2.2
Requires:       python%{python3_pkgversion}-click < 9.0
Requires:       python%{python3_pkgversion}-cryptography
Requires:       python%{python3_pkgversion}-django >= 3.2.15
Requires:       python%{python3_pkgversion}-django < 3.3
Requires:       python%{python3_pkgversion}-django-currentuser >= 0.5.3
Requires:       python%{python3_pkgversion}-django-currentuser < 0.6
Requires:       python%{python3_pkgversion}-django-filter >= 22.1
Requires:       python%{python3_pkgversion}-django-filter < 23
Requires:       python%{python3_pkgversion}-django-guid >= 3.3
Requires:       python%{python3_pkgversion}-django-guid < 4
Requires:       python%{python3_pkgversion}-django-import-export >= 2.8.0
Requires:       python%{python3_pkgversion}-django-import-export < 2.9
Requires:       python%{python3_pkgversion}-django-lifecycle >= 1.0.0
Requires:       python%{python3_pkgversion}-django-lifecycle < 1.1.0
Requires:       python%{python3_pkgversion}-django-prometheus
Requires:       python%{python3_pkgversion}-djangorestframework >= 3.13.1
Requires:       python%{python3_pkgversion}-djangorestframework < 3.14
Requires:       python%{python3_pkgversion}-djangorestframework-queryfields >= 1.0.0
Requires:       python%{python3_pkgversion}-djangorestframework-queryfields < 1.1
Requires:       python%{python3_pkgversion}-drf-access-policy >= 1.1.2
Requires:       python%{python3_pkgversion}-drf-access-policy < 1.2
Requires:       python%{python3_pkgversion}-drf-nested-routers = 0.93.4
Requires:       python%{python3_pkgversion}-drf-spectacular = 0.23.1
Requires:       python%{python3_pkgversion}-dynaconf >= 3.1.9
Requires:       python%{python3_pkgversion}-dynaconf < 3.2
Requires:       python%{python3_pkgversion}-gnupg >= 0.5.0
Requires:       python%{python3_pkgversion}-gnupg < 0.6
Requires:       python%{python3_pkgversion}-gunicorn >= 20.1.0
Requires:       python%{python3_pkgversion}-gunicorn < 20.2
Requires:       python%{python3_pkgversion}-jinja2 >= 3.1
Requires:       python%{python3_pkgversion}-jinja2 < 4
Requires:       python%{python3_pkgversion}-naya >= 1.1.1
Requires:       python%{python3_pkgversion}-naya < 1.2
Requires:       python%{python3_pkgversion}-protobuf < 4.22
Requires:       python%{python3_pkgversion}-psycopg2 >= 2.9.3
Requires:       python%{python3_pkgversion}-psycopg2 < 2.10
Requires:       python%{python3_pkgversion}-pygtrie >= 2.5.0
Requires:       python%{python3_pkgversion}-pygtrie < 2.6
Requires:       python%{python3_pkgversion}-redis >= 4.3
Requires:       python%{python3_pkgversion}-redis < 5
Requires:       python%{python3_pkgversion}-setuptools >= 39.2.0
Requires:       python%{python3_pkgversion}-setuptools < 66.0.0
Requires:       python%{python3_pkgversion}-url-normalize >= 1.4.3
Requires:       python%{python3_pkgversion}-url-normalize < 1.5
Requires:       python%{python3_pkgversion}-whitenoise >= 5.0.0
Requires:       python%{python3_pkgversion}-whitenoise < 6.3.0
Requires:       python%{python3_pkgversion}-yarl >= 1.7
Requires:       python%{python3_pkgversion}-yarl < 2

Obsoletes:      python3-%{pypi_name} < %{version}-%{release}
Obsoletes:      python3-django-guardian
%if 0%{?rhel} == 8
Obsoletes:      python38-%{pypi_name} < %{version}-%{release}
Obsoletes:      python38-django-guardian
%endif

Provides:       %{pypi_name} = %{version}

%description -n python%{python3_pkgversion}-%{pypi_name}
Pulp is a platform for managing repositories of content, such as software
packages, and pushing that content out to large numbers of consumers.

Using Pulp you can:
- Locally mirror all or part of a repository
- Host your own content in a new repository
- Manage content from multiple sources in one place
- Promote content through different repos in an organized way

%prep
set -ex
%autosetup -n python-%{pypi_name}-%{commitId}
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

# relax cryptography requirement
# see https://pulp.plan.io/issues/9367
sed -i '/cryptography/ s/>=.*//' requirements.txt

%build
set -ex
%py3_build

for wrapper in %{wrappers}
do
  printf '#!/bin/bash\nexec %s "$@"\n' ${wrapper} > ${wrapper}
done

%install
set -ex
%py3_install

for wrapper in %{wrappers}
do
  install -D -m 755 ${wrapper} %{buildroot}%{_libexecdir}/%{pypi_name}/${wrapper}
done

%files -n python%{python3_pkgversion}-%{pypi_name}
%license LICENSE
%doc README.md
%{_bindir}/pulp-content
%{_bindir}/pulpcore-manager
%{_bindir}/pulpcore-worker
%{_libexecdir}/%{pypi_name}/*
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{version}*-py%{python3_version}.egg-info

%changelog
* Thu Dec 15 2022 Satoe Imaishi <simaishi@redhat.com> - 3.21.3-1
- Update to 3.21.3

* Tue Oct 25 2022 Dimitri Savineau <dsavinea@redhat.com> - 3.21.0-2
- Obsoletes python-django-guardian

* Thu Oct 13 2022 Satoe Imaishi <simaishi@redhat.com> - 3.21.0-1
- Initial Build
